-- Filename:     mux4.vhd
-- Filetype:     VHDL code (dataflow)
-- Date:         9 feb 2014
-- Update:       -
-- Description:  An example of a CSA
-- Author:       J. op den Brouw
-- State:        demo
-- Error:        -
-- Version:      1.0
-- Copyright:    (c)2014, De Haagse Hogeschool
--
-- This is an example of a Selected Signal Assignment
-- which implements a 4-input multiplexer.
--
-- We need std_logic et al.

library ieee;
use ieee.std_logic_1164.all;

entity mux4 is
    port (in0,in1,in2,in3: in std_logic;
          sel: in std_logic_vector (1 downto 0);
          z : out std_logic);
end entity mux4;

architecture ssa of mux4 is
begin
    with sel select
    z <= in0  when "00",
         in1  when "01",
         in2  when "10",
         in3  when "11",
         'X'  when others;
end architecture ssa;
